//
//  HyxenLibProMeHyXenOfflinePushService.h
//  ZeroCard
//
//  Created by Hyxen on 2011/10/13.
//  Copyright 2011年 Hyxen Tech Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreLocation/CoreLocation.h>
#import <AVFoundation/AVFoundation.h>
//#import "HyxenLibProMeComet.h"
#import "HyxenLibProMeSettings.h"
#import "HyxenLibProMeMessageListener.h"

//#import "HyxenLibProMeHyXenAnaltyicsService.h"

//#import "HyxenLibProMePushLayoutManager.h"

//#import "BSForwardGeocoder.h"
#import "AdLocusReachability.h"

#import "HyxenAdWebBrowserController.h"

@protocol HyXenProMeOffPushlineServiceDelegate; 

@interface HyxenLibProMeHyXenOfflinePushService : NSObject< CLLocationManagerDelegate, UIActionSheetDelegate, HyxenAdWebBrowserControllerDelegate > {//HyxenLibProMeCometDelegate,BSForwardGeocoderDelegate

    NSString *hxJsonLink;
    //HyxenLibProMeHyXenAnaltyicsService *hxAnaService;
    int SDKVersion;
    BOOL enablePushService;
    NSString *hxAppKey;
    NSString *hxCometHost;
    NSString *hxCometPort;
    NSString *hxCometUrl;
    NSMutableDictionary *hxCometDict;
    NSString *hxPushLacUrl;
    NSString *hxPushCiUrl;
    
    NSString *hxOffPushCheckUrl;
    NSString *hxOffPushFeedBackUrl;
    NSString *hxOffPushCouponGetUrl;
    NSString *hxOffPushCouponSmartPoiUrl;
    NSString *hxOffPushCouponActImgUrl;
    NSString *hxOffPushSubmitUrl;
    NSString *hxOffAnaAddUrl;
    NSString *hxOffGeoNoteAddUrl;
    NSString *hxOffGeoNoteRemoveUrl;
    NSString *hxOffEventInfoUrl;
    //ForPush
    //HyxenLibProMeComet *hxComet;
    HyxenLibProMeSettings  *hxSettings; 
    NSTimer *scheduleTimer;
    NSTimer *theClosedFurtureTimer;
    
    BOOL isGettingHxPushMsg;
    BOOL isGettingHxPushCi;
    
    BOOL isGettingOffPushMsg;
    BOOL isDownloadingOffPushMsg;
    
    BOOL isGettingPushStepTwo;
    NSNumber *pushStepTwoCount;
    NSNumber *waitTimeoutCount;

    
    
    NSNumber *mLastClearFeedbackListTimes;
    NSNumber *mLastTypeThreeTimes;;
    BOOL isSettingOffLinePushRegion;
    NSDate  *theClosedFurture;
    
    BOOL hasMCCInfo;
    NSMutableDictionary *hxPushLacDict;
    CLLocationManager *hxLocationManager;
    NSString *hxMcc;
    NSString *hxMnc;
    CLLocation *hxOldGetPushCenter;
    CLLocation *hxLastcheckPosition;
    NSOperationQueue *hxDownloadQueue;
    HyxenLibProMeMessageListener *hxMessageListener;

    UIActionSheet *menu;
    UIPickerView *pickerViewCitys;
    NSMutableArray *citysArray;
    NSMutableArray *distinctArray;
    
    //HyxenLibProMePushLayoutManager *hxPushLayoutManager;
    HyxenAdWebBrowserController *hxWebBrowserController;
    NSString *noLocPushCity;
//    BSForwardGeocoder *forwardGeocoder;
    AdLocusReachability* hxInternetReachable;
    //delegate
    id <HyXenProMeOffPushlineServiceDelegate> delegate;
    CLLocationManager *locManager;
    
    NSString *lastPageName;
    NSMutableDictionary *hxPushContent;
    int pushCount;
    
    BOOL pushTypeThreeFlag;
    NSMutableDictionary *pushTypeThreeDict;
    
     
}
@property (nonatomic)           BOOL enablePushService;
//@property (nonatomic, retain)   HyxenLibProMeHyXenAnaltyicsService *hxAnaService;
@property (readonly) int SDKVersion;
@property (nonatomic, retain) NSString *hxAppKey;
@property (nonatomic, retain) NSString *hxJsonLink;
//@property (nonatomic, retain)   HyxenLibProMePushLayoutManager *hxPushLayoutManager;
//@property (nonatomic, retain)   HyxenLibProMeComet *hxComet;
@property (nonatomic, retain)   HyxenLibProMeSettings  *hxSettings; 
@property (nonatomic)           BOOL isGettingHxPushMsg;
@property (nonatomic)           BOOL isGettingHxPushCi;
@property (nonatomic)           BOOL isSettingOffLinePushRegion;
@property (nonatomic)           BOOL isGettingOffPushMsg;
@property (nonatomic)           BOOL isDownloadingOffPushMsg;
@property (nonatomic)           BOOL hasMCCInfo;

@property (nonatomic)           BOOL pushTypeThreeFlag;
@property (nonatomic, retain)   NSMutableDictionary *pushTypeThreeDict;

@property (nonatomic)           BOOL isGettingPushStepTwo;
@property (nonatomic, retain)   NSNumber *pushStepTwoCount;

@property (nonatomic, retain)   NSNumber *waitTimeoutCount;


@property (nonatomic, retain)    NSNumber * mLastClearFeedbackListTimes;
@property (nonatomic, retain)    NSNumber * mLastTypeThreeTimes;

@property (nonatomic, retain)   NSTimer *scheduleTimer;
@property (nonatomic, retain)   NSDate  *theClosedFurture;
@property (nonatomic, retain)   NSTimer *theClosedFurtureTimer;
@property (nonatomic, retain)   NSMutableDictionary *hxPushLacDict;
@property (nonatomic, retain)   CLLocationManager *hxLocationManager;
@property (nonatomic, retain)   NSString *hxMcc;
@property (nonatomic, retain)   NSString *hxMnc;
@property (nonatomic, retain)   CLLocation *hxOldGetPushCenter;
@property (nonatomic, retain)   CLLocation *hxLastcheckPosition;
@property (nonatomic, retain)   NSOperationQueue *hxDownloadQueue;
@property (nonatomic, retain)   HyxenLibProMeMessageListener *hxMessageListener;
@property (nonatomic, retain)   NSString *hxCometHost;
@property (nonatomic, retain)   NSString *hxCometPort;
@property (nonatomic, retain)   NSString *hxCometUrl;
@property (nonatomic, retain)   NSMutableDictionary *hxCometDict;
@property (nonatomic, retain)   NSString *hxPushLacUrl;
@property (nonatomic, retain)   NSString *hxPushCiUrl;
@property (nonatomic, retain)   NSString *hxOffPushCheckUrl;
@property (nonatomic, retain)   NSString *hxOffPushFeedBackUrl;
@property (nonatomic, retain)   NSString *hxOffPushCouponGetUrl;
@property (nonatomic, retain)   NSString *hxOffPushCouponSmartPoiUrl;
@property (nonatomic, retain)   NSString *hxOffPushCouponActImgUrl;
@property (nonatomic, retain)   NSString *hxOffAnaAddUrl;
@property (nonatomic, retain)   NSString *hxOffPushSubmitUrl;
@property (nonatomic, retain)   NSString *hxOffGeoNoteAddUrl;
@property (nonatomic, retain)   NSString *hxOffGeoNoteRemoveUrl;
@property (nonatomic, retain)   NSString *hxOffEventInfoUrl;


@property (nonatomic, retain) NSString *lastPageName;

@property (nonatomic, retain)   id <HyXenProMeOffPushlineServiceDelegate> delegate;
+(BOOL)appHasBackGroundLocation;
-(void)startOfflinePushService;
-(void)showSettingPage;
-(void)stopPushService;
-(void)setPushRegion;
-(void)setOffLinePushRegion;
-(void)setNoLocationPush;
-(void)setUpTimerThread;
-(BOOL)checkLocationServiceEnable;
-(void) HyxenLibProMeCheckNetworkStatus:(NSNotification *)notice;
-(void) createDBTalbe;
+(void) setUrlbyPidJson:(NSString *)pidJson;
+(void) applicationLauching;
-(void) applicationLauching;
-(void)appLauch;
+(void)stopTimer;
-(void)stoptheClosedFurtureTimer;
+(void)waitTimeOut;
-(void)scheduleToGetPushEventWithTheSeconds:(int)sec andEventId:(NSString *)eventID;
+(void)waitHourly;
+(void) applicationEnterBackGround;
+(void) applicationBecomeActive;
+(void)didReceiveLocalNotification:(UILocalNotification *)notif;
+(void)didReceiveLocalNotifications:(NSDictionary *)userinfo;
+(void)performFetchWithCompletionHandler:(void (^)(UIBackgroundFetchResult))completionHandler;
@end

@protocol HyXenProMeOffPushlineServiceDelegate   
@optional
-(NSString *)hyxenADAppKey;
- (NSString *)gender; // user's gender (e.g. @"1" is Male or @"2" is Female)
- (NSNumber *)age;
- (BOOL)testMode;
@end