//
//  HyxenLibProMeMessageListener.h
//  GeoMe
//
//  Created by Hyxen on 2011/5/16.
//  Copyright 2011年 Hyxen Tech Inc.. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <CoreLocation/CoreLocation.h>
#import <UIKit/UIKit.h>




@interface HyxenLibProMeMessageListener : NSObject<CLLocationManagerDelegate >
{
	BOOL isGettingMsg;
	NSTimeInterval lastPlaySound;
    NSString *documentPath;
    NSString *photoPath;
    NSString *fileName;

}
+ (id)sharedListener;

@end

@interface HyxenLibProMeMessageListener (Private)
+ (void)alarmWithString:(NSString *)message;
+(void)getPushMessages;
+(void)getPushCiMessagesWithLac:(NSString *) lac andCi:(NSString *)ci;
+(void)getOfflinePushMessages;
+(void)getOfflinePushMessagesStepTwo;
+(void)feedBackOffPushID;
+(void)waitTimeOut;
+ (void)downloadDBFromURL:(NSString *)url andOffPushID:(NSNumber *)offPushID;

-(NSString *)getDocumentPath;
- (BOOL)saveImage:(UIImage *)image photoFrom:(NSString *)photoFrom ;
@end